<template>
  <div v-if="product" class="product-page">
    <v-jumbotron
      :src="product.imageUrl"
      gradient="to top right, rgba(0,0,0,0.5), rgba(0,0,0,0.5)"
      dark
    >
      <v-container fill-height>
        <v-layout align-center>
          <v-flex text-xs-center>
            <h3 class="display-3">{{product.name}}</h3>
            <h2 class="display-5"></h2>
            <p>{{product.description}}</p>
            <v-btn @click="addToCart" color="warning">€{{product.price}} - In winkelwagen</v-btn>
          </v-flex>
        </v-layout>
      </v-container>
    </v-jumbotron>
    <v-container fluid>
      <v-layout row wrap>
        <v-flex sm12>
          <p
            v-if="watchers > 0"
          >{{watchers}} {{(watchers === 1 ? "ander persoon bekijkt" : "andere bekijken")}} dit product nu ook! Hieronder kun je met de andere chatten.</p>
          <h2>Chat</h2>
        </v-flex>
        <v-flex sm6>
          <v-flex sm10>
            <v-textarea v-model="message" box></v-textarea>
            <v-btn :disabled="!message" @click="sendMessage" color="primary">Verstuur</v-btn>
          </v-flex>
        </v-flex>
        <v-flex sm6>
          <v-textarea solo readonly :value="formatMessages()"></v-textarea>
        </v-flex>
      </v-layout>
    </v-container>
  </div>
</template>

<script>
import { randomName } from "@/utillities";

export default {
  data() {
    return {
      productId: undefined,
      product: undefined,
      watchers: undefined,
      socket: undefined,
      messages: [],
      message: undefined
    };
  },

  async mounted() {
    this.productId = this.$route.params.id;
    this.product = await this.$productService.getById(this.productId);

    this.socket = new WebSocket(`ws://localhost:8001/observe/${this.productId}/${randomName()}`);

    this.socket.onmessage = event => {
      const message = JSON.parse(event.data);

      switch (message.type) {
        case "watchers-change":
          this.watchers = message.watchers - 1;
          break;
        case "chat-message":
          this.messages.push(message);
      }
    };
  },

  methods: {
    formatMessages() {
      return this.messages.map(m => `${m.from}: ${m.message}`).join("\n");
    },

    sendMessage() {
      this.socket.send(this.message);
    },

    addToCart() {
      this.$store.commit("addToCart", this.product);
    }
  },

  beforeDestroy() {
    this.socket.close();
  }
};
</script>

<style>
</style>
